﻿TACTIC_MSG_CH = "TTC2";
TACTIC_TEMP_MSG = {};

function Tacticator_toggle_visible()
  if(Tacticator:IsShown()) then
    Tacticator:Hide();
  else
    Tacticator:Show();
  end
end

function TacticDisplay_Toggle_Visible()
	TacticDisplay:Show();
end

function Tacticator_OnLoad()
  local version = GetAddOnMetadata("Tacticator", "Version");
  Tacticator_SetVariables();
  this:RegisterEvent("VARIABLES_LOADED");

  SlashCmdList["Tacticator"] = function(msg)
    Tacticator_SlashCommand(msg);
  end;
  --SLASH_Tacticator1 = "/tactic";
  SLASH_Tacticator1 = "/tacticator";
  
  if( DEFAULT_CHAT_FRAME ) then
    DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Tacticator v"..version.." loaded");
  end
  UIErrorsFrame:AddMessage("Tacticator v"..version.." AddOn loaded", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
  if moblist then
  	TacticatorTacticGD:Enable();
  else
  	TacticatorTacticGD:Disable();
  end
  Tacticator:Hide();
end

function TacticDisplay_OnLoad()
	this:RegisterEvent("CHAT_MSG_ADDON");
	TacticDisplay:Hide();
end

function Tacticator_OnEvent()
	if (event=="VARIABLES_LOADED") then
		Tacticator:ClearAllPoints();
		Tacticator:SetPoint("BOTTOMLEFT","UIParent", "BOTTOMLEFT", TacticatorSavings.dispx, TacticatorSavings.dispy);
		TacticDisplay:SetPoint("BOTTOMLEFT","UIParent", "BOTTOMLEFT", TacticatorSavings.historyDispx, TacticatorSavings.historyDispy);
		local i;
		if not(TacticatorSavings.TACTIC_INSTANCE) then
			TacticatorSavings.TACTIC_INSTANCE = {};
		end
		TacticatorDropDownInstance_Initialize();
		TacticatorConfig_OnCancelOrLoad();
	end
end

function TacticatorConfig_OnCancelOrLoad()
	TacticatorConfigFrameRaid:SetChecked(TacticatorSavings.showRaid);
	TacticatorConfigFrameParty:SetChecked(TacticatorSavings.showParty);
	TacticatorConfigFrameBG:SetChecked(TacticatorSavings.showBG);
	TacticatorConfigFramePopup:SetChecked(TacticatorSavings.showPopup);
end

function Tacticator_SetVariables()
  if not(TacticatorSavings) then
    TacticatorSavings = {};
    TacticatorSavings.dispx = GetScreenWidth()/2 - 200;
    TacticatorSavings.dispy = GetScreenHeight()/2 - 200;
	TacticatorSavings.historyDispx = GetScreenWidth()/2 - 200;
	TacticatorSavings.historyDispy = GetScreenHeight()/2 - 200;
    TacticatorSavings.TACTIC_INSTANCE = {};
    TacticatorSavings.showRaid = true;
    TacticatorSavings.showParty = true;
    TacticatorSavings.showBG = true;
    TacticatorSavings.showPopup = true;
  end
  TacticatorDropDownInstance_Initialize();
end

function Tacticator_SlashCommand(msg)
  if(msg) then
    local command = string.lower(msg);
    if(command == "hide") then
      Tacticator:Hide();
    else
	  if(command == "history") then
	    TacticDisplay:Show();
	  else
        Tacticator:Show();
      end
    end
  end
end

function Tacticator_SavePosition()
  TacticatorSavings.dispx = this:GetLeft();
  TacticatorSavings.dispy = this:GetBottom();
end

function TacticatorDisplay_SavePosition()
  TacticatorSavings.historyDispx = this:GetLeft();
  TacticatorSavings.historyDispy = this:GetBottom();
end

function Tacticator_OnSave()
	local instance = UIDropDownMenu_GetSelectedID(TacticatorDropDownInstance);
	local box = getglobal("TacticatorScrollContainerScrollFrameEditBox");
	local tacticText = box:GetText();
	if tacticText and not(tacticText == "") then
		TacticatorSavings.TACTIC_INSTANCE[instance].tactic = tacticText;
	end
end

function Tacticator_OnAdd()
	local instance = getglobal("TacticatorInstance");
	local text = instance:GetText();
	if text and not(text == "") then
		tactic = {
			name = text;
			tactic = "";
		};
		TacticatorSavings.TACTIC_INSTANCE[getn(TacticatorSavings.TACTIC_INSTANCE) + 1] = tactic;
	end
	instance:SetText("");
	TacticatorDropDownInstance_Initialize();
end

function Tacticator_OnRename()
	local instance = getglobal("TacticatorInstance");
	local instanceSelected = UIDropDownMenu_GetSelectedID(TacticatorDropDownInstance);
	local text = instance:GetText();
	if text and not(text == "") and instanceSelected and (instanceSelected > 0) then
		TacticatorSavings.TACTIC_INSTANCE[instanceSelected].name = text;
		instance:SetText("");
		UIDropDownMenu_ClearAll(TacticatorDropDownInstance);
		TacticatorDropDownInstance_Initialize();
		UIDropDownMenu_SetSelectedID(TacticatorDropDownInstance, instanceSelected);
		UIDropDownMenu_SetText(TacticatorDropDownInstance, text);
	end
end

function Tacticator_OnClear()
  local obj = getglobal("TacticatorScrollContainerScrollFrameEditBox");
  obj:SetText("");
end

function Tacticator_OnClose()
  Tacticator:Hide();
end

function TacticDisplay_OnClose()
  TacticDisplay:Hide();
end

function TacticatorDropDownInstance_OnShow()
	UIDropDownMenu_Initialize(TacticatorDropDownInstance, TacticatorDropDownInstance_Initialize);
	UIDropDownMenu_SetSelectedID(TacticatorDropDownInstance, 0);
	UIDropDownMenu_SetWidth(TacticatorDropDownInstance, 100);
end

function TacticatorDropDownInstance_Initialize()
	local i;
	if not TacticatorSavings then
		Tacticator_SetVariables();
	end
	if(getn(TacticatorSavings.TACTIC_INSTANCE) > 0) then
		for i = 1, getn(TacticatorSavings.TACTIC_INSTANCE), 1 do
			info = {
				text = TacticatorSavings.TACTIC_INSTANCE[i].name;
				func = TacticatorDropDownInstance_OnClick;
			};
			UIDropDownMenu_AddButton(info);
			i = i + 1;
		end
	end
end

function TacticDisplayDropDownReceived_OnShow()
	UIDropDownMenu_Initialize(TacticDisplayDropDownReceived, TacticDisplayDropDownReceived_Initialize);
	UIDropDownMenu_SetSelectedID(TacticDisplayDropDownReceived, 0);
	UIDropDownMenu_SetWidth(TacticDisplayDropDownReceived, 100);
end

function TacticDisplayDropDownReceived_Initialize()
	local i;
	if(getn(TACTIC_TEMP_MSG) > 0) then
		for i = 1, getn(TACTIC_TEMP_MSG), 1 do
			info = {
				text = TACTIC_TEMP_MSG[i].sender.." : "..i;
				func = TacticDisplayDropDownReceived_OnClick;
			};
			UIDropDownMenu_AddButton(info);
			i = i + 1;
		end
		UIDropDownMenu_SetSelectedID(TacticDisplayDropDownReceived, getn(TACTIC_TEMP_MSG));
	end
end

function TacticDisplayDropDownReceived_OnClick()
	local thisID = this:GetID();
	UIDropDownMenu_SetSelectedID(TacticDisplayDropDownReceived, thisID);
	local box = getglobal("TacticDisplayScrollContainerScrollFrameEditBox");
	box:SetText(strsub(TACTIC_TEMP_MSG[thisID].tactic, 1, strlen(TACTIC_TEMP_MSG[thisID].tactic)-1));
end

function Tacticator_OnDelete()
	local id = UIDropDownMenu_GetSelectedID(TacticatorDropDownInstance);
	tremove(TacticatorSavings.TACTIC_INSTANCE, id);
	UIDropDownMenu_ClearAll(TacticatorDropDownInstance);
	TacticatorDropDownInstance_Initialize();
	local box = getglobal("TacticatorScrollContainerScrollFrameEditBox");
	box:SetText("");	
end

function TacticatorDropDownInstance_OnClick()
	local thisID = this:GetID();
	UIDropDownMenu_SetSelectedID(TacticatorDropDownInstance, thisID);
	local box = getglobal("TacticatorScrollContainerScrollFrameEditBox");
	box:SetText(TacticatorSavings.TACTIC_INSTANCE[thisID].tactic);	
end

function Tacticator_OnSayClick()
	getglobal("TacticatorCheckParty"):SetChecked(false);
	getglobal("TacticatorCheckSay"):SetChecked(true);
	getglobal("TacticatorCheckRaid"):SetChecked(false);
	getglobal("TacticatorCheckRaidWarning"):SetChecked(false);
	getglobal("TacticatorCheckBattleground"):SetChecked(false);
	getglobal("TacticatorCheckChannelNo"):SetChecked(false);
end

function Tacticator_OnPartyClick()
	getglobal("TacticatorCheckParty"):SetChecked(true);
	getglobal("TacticatorCheckSay"):SetChecked(false);
	getglobal("TacticatorCheckRaid"):SetChecked(false);
	getglobal("TacticatorCheckRaidWarning"):SetChecked(false);
	getglobal("TacticatorCheckBattleground"):SetChecked(false);
	getglobal("TacticatorCheckChannelNo"):SetChecked(false);
end

function Tacticator_OnRaidClick()
	getglobal("TacticatorCheckParty"):SetChecked(false);
	getglobal("TacticatorCheckSay"):SetChecked(false);
	getglobal("TacticatorCheckRaid"):SetChecked(true);
	getglobal("TacticatorCheckRaidWarning"):SetChecked(false);
	getglobal("TacticatorCheckBattleground"):SetChecked(false);
	getglobal("TacticatorCheckChannelNo"):SetChecked(false);
end

function Tacticator_OnRaidWarningClick()
	getglobal("TacticatorCheckParty"):SetChecked(false);
	getglobal("TacticatorCheckSay"):SetChecked(false);
	getglobal("TacticatorCheckRaid"):SetChecked(false);
	getglobal("TacticatorCheckRaidWarning"):SetChecked(true);
	getglobal("TacticatorCheckBattleground"):SetChecked(false);
	getglobal("TacticatorCheckChannelNo"):SetChecked(false);
end

function Tacticator_OnBattlegroundClick()
	getglobal("TacticatorCheckParty"):SetChecked(false);
	getglobal("TacticatorCheckSay"):SetChecked(false);
	getglobal("TacticatorCheckRaid"):SetChecked(false);
	getglobal("TacticatorCheckRaidWarning"):SetChecked(false);
	getglobal("TacticatorCheckBattleground"):SetChecked(true);
	getglobal("TacticatorCheckChannelNo"):SetChecked(false);
end

function Tacticator_OnChannelNoClick()
	getglobal("TacticatorCheckParty"):SetChecked(false);
	getglobal("TacticatorCheckSay"):SetChecked(false);
	getglobal("TacticatorCheckRaid"):SetChecked(false);
	getglobal("TacticatorCheckRaidWarning"):SetChecked(false);
	getglobal("TacticatorCheckBattleground"):SetChecked(false);
	getglobal("TacticatorCheckChannelNo"):SetChecked(true);
end

function Tacticator_OnSend()
	local box = getglobal("TacticatorScrollContainerScrollFrameEditBox");
	local tacticText = box:GetText();
	local continueVar = true;
	local channel = "RAID";
	local no = nil;
	local channelRequired = false;
	if(getglobal("TacticatorCheckParty"):GetChecked()) then
		channel = "PARTY";
	else
		if(getglobal("TacticatorCheckSay"):GetChecked()) then
			channel = "SAY";
		else
			if(getglobal("TacticatorCheckRaidWarning"):GetChecked()) then
				channel = "RAID_WARNING";
			else
				if(getglobal("TacticatorCheckBattleground"):GetChecked()) then
					channel = "BATTLEGROUND";
				else
					if(getglobal("TacticatorCheckChannelNo"):GetChecked()) then
						channel = "CHANNEL";
						no = getglobal("TacticatorChannelNo"):GetText();
						channelRequired = true;
					end
				end
			end
		end
	end
	local tempChannel;
	if(channel == "PARTY" or channel == "RAID" or channel == "BATTLEGROUND" or channel == "RAID_WARNING") then
		if(channel == "RAID_WARNING") then
			tempChannel = "RAID";
		else
			tempChannel = channel;
		end
	end
	if((not(no) or (no == "")) and channelRequired) then
	else
		while (continueVar == true) do
			local pos1 = strfind(tacticText, strchar(10));
			if(not(pos) and (strlen(tacticText)+strlen(TACTIC_MSG_CH)+strlen(UnitName("player")) > 253 )) then
				pos1 = 253-strlen(TACTIC_MSG_CH)-strlen(UnitName("player"));
			end
			if(pos1) then
				if(pos1+strlen(TACTIC_MSG_CH)+strlen(UnitName("player")) > 253) then
					pos1 = 253 - strlen(TACTIC_MSG_CH)-strlen(UnitName("player"));
				end
				if(no) then
					SendChatMessage(strsub(tacticText,1,pos1), channel, nil, no);
				else
					SendChatMessage(strsub(tacticText,1,pos1), channel);
				end
				if(tempChannel) then
					SendAddonMessage(TACTIC_MSG_CH, UnitName("player")..":"..strsub(tacticText,1,pos1), tempChannel);
				end
				tacticText = strsub(tacticText, pos1+1);
			else
				if(strlen(tacticText) > 0) then
					if(no) then
						SendChatMessage(tacticText, channel, nil, no);
					else
						SendChatMessage(tacticText, channel);
					end
				end
				if(tempChannel) then
					SendAddonMessage(TACTIC_MSG_CH, UnitName("player")..":"..tacticText, tempChannel);
				end
				continueVar = false;
			end
		end
		SendAddonMessage(TACTIC_MSG_CH, UnitName("player")..":"..strchar(23), tempChannel);
	end
end

function TacticDisplay_OnEvent()
	if(event =="CHAT_MSG_ADDON") then
		TacticDisplay_HandleMessage(arg1, arg2, arg3);
	end
end

function TacticDisplay_HandleMessage(prefix, text, channel)
	if(prefix == TACTIC_MSG_CH and ((channel == "RAID" and TacticatorSavings.showRaid) or (channel == "PARTY" and TacticatorSavings.showParty) or (channel == "BATTLEGROUND" and TacticatorSavings.showBG))) then
		local token = strfind(text, ":");
  		if(token) then
  			local inSender = strsub(text, 1, token -1);
  			local inTactic = strsub(text, token+1);
  			local matched = false;
  			if not(inSender == UnitName("player")) then
  				if TacticatorSavings.showPopup then
					TacticDisplay:Show();
				end
  				if(getn(TACTIC_TEMP_MSG) > 0) then
		  			for i = 1, getn(TACTIC_TEMP_MSG), 1 do
  						if (TACTIC_TEMP_MSG[i].sender == inSender) and not(strsub(TACTIC_TEMP_MSG[i].tactic, strlen(TACTIC_TEMP_MSG[i].tactic))==strchar(23)) then
		  					TACTIC_TEMP_MSG[i].tactic = TACTIC_TEMP_MSG[i].tactic .. inTactic;
  							matched = true;
  						end
  					end
  				end
  				if (not matched) then
					local new = {
  						sender = inSender;
  						tactic = inTactic;
  					};
  					TACTIC_TEMP_MSG[getn(TACTIC_TEMP_MSG)+1] = new;
  				end
  				if strbyte(TACTIC_TEMP_MSG[getn(TACTIC_TEMP_MSG)].tactic, strlen(TACTIC_TEMP_MSG[getn(TACTIC_TEMP_MSG)].tactic)) == 23 then
	  				TacticDisplayDropDownReceived_Initialize();
	  				UIDropDownMenu_SetSelectedID(TacticDisplayDropDownReceived, getn(TACTIC_TEMP_MSG));
					local box = getglobal("TacticDisplayScrollContainerScrollFrameEditBox");
					box:SetText(gsub(TACTIC_TEMP_MSG[getn(TACTIC_TEMP_MSG)].tactic, strchar(23), ""));
				end
			end
  		end
	end
end

function TacticatorConfigFrame_OnLoad(panel)
    panel.name = "Tacticator " .. GetAddOnMetadata("Tacticator", "Version");
    panel.okay = function(self) TacticatorConfig_Ok(); end;
    panel.cancel = function(self)  TacticatorConfig_OnCancelOrLoad();  end;
    InterfaceOptions_AddCategory(panel);
end

function TacticatorConfig_Ok()
    TacticatorSavings.showRaid = TacticatorConfigFrameRaid:GetChecked();
    TacticatorSavings.showParty = TacticatorConfigFrameParty:GetChecked();
    TacticatorSavings.showBG = TacticatorConfigFrameBG:GetChecked();
    TacticatorSavings.showPopup = TacticatorConfigFramePopup:GetChecked();
end

function TacticDisplay_OnCopy()
	local i = getn(TacticatorSavings.TACTIC_INSTANCE)+1;
	local box = getglobal("TacticDisplayScrollContainerScrollFrameEditBox");
	local nameIn = getglobal("TacticDisplayName"):GetText();
	local id = UIDropDownMenu_GetSelectedID(TacticDisplayDropDownReceived);
	if(not nameIn or nameIn == "") then
		nameIn = TACTIC_TEMP_MSG[id].sender..":"..id;
	end
	local new = {
		name = nameIn;
		tactic = box:GetText();
	};
	TacticatorSavings.TACTIC_INSTANCE[i] = new;
end

function Tacticator_RaidTarget(tag)
	TacticatorScrollContainerScrollFrameEditBox:Insert(tag);
end

function Tacticator_ImportGD()
	local mobname = UnitName("target");
	for mob in pairs(moblist) do
		for nameidx in pairs(moblist[mob].name) do
			if (moblist[mob].name[nameidx]==mobname) then
				Tacticator_DescribeGD(moblist[mob]);
				return;
			end
		end
		for nameidx in pairs(moblist[mob].shortName) do
			if (moblist[mob].shortName[nameidx]==mobname) then
				Tacticator_DescribeGD(moblist[mob]);
				return;
			end
		end
	end
  if( DEFAULT_CHAT_FRAME ) then
    DEFAULT_CHAT_FRAME:AddMessage("|cffff2222Mob not found");
  end
end

function Tacticator_DescribeGD(mob)
	for line in pairs(mob.description) do
		TacticatorScrollContainerScrollFrameEditBox:Insert(mob.description[line]);
		TacticatorScrollContainerScrollFrameEditBox:Insert(strchar(10));
	end
end